# General

Tries to automate the steps described here:
https://redmine.digitalstrom.org/projects/dss/wiki/How_to_build_the_dSS

You need to checkout [ds-os](https://git.digitalstrom.org/dss/ds-os) or
at least mimick its folder structure for building ds485 libraries

> run.sh script assume its checked out at "/home/${USER}/dSS/ds-os"

After checkout of ds-os, there is a dss-mainline folder as well. It is assumed
that will be your new work folder.

vhome is mounted as virtual home directory inside the docker.
Copy git configuraion and personal settings there


  -- vhome (folder within docker/vhome )
    | -- ds-os (ds-os checkout)
        | -- dss-mainline (subfolder from ds-os checkout)


You have sudo rights inside the container, so you can quickly add missing a packet.

> password less sudo rights within the container is insecure


# Build external dependencies

These are built together with the container

``sh
    ./build
``

This will generate the non-standard packages
- [json-c](missing link)
- [rapidjson](https://github.com/Tencent/rapidjson)

once they become part of the distribution they can be removed

as well as the obsoletet spider monkey 1.8.5, that has been removed from most
distributions alraedy

- [mozjs185](..)

# Build digitalStrom dependencies

These are:
- ds485 stack (client + dsm-api)
- libcommchannel (dsa/dss communication)

We are still relying on the
[env](https://redmine.digitalstrom.org/projects/dss/wiki/How_to_build_the_dSS#Building-the-dS485-Stack)
script trick

But we arleady provided one inside of the docker/ folder. So don't need create one
if you followed the directory structure above.
Just instantiate the container and run the compile script

``sh
    ./run.sh
    ./compile-ds485.sh

``

> You only need to do this at the beginning and when there changes in the projects


# Build dSS mainline

Just follow the README.md in the dss-mainline root folder
Everything should be installed and prepared

> you can re-use the env.sh from the docker folder
