#!/bin/bash

set -e

. env.sh

cd $DS_OS

do_make() {
    pushd $1
    make PREFIX=$PREFIX install
    popd
}

do_autoconf() {
    pushd $1
    autoreconf -i
    ./configure --prefix=${PREFIX}
    make -j $(nproc)
    make install
    popd
}

do_make() {
    pushd $1
    make install
    popd
}

do_cmake() {
    # aptitude install swig python-dev
    pushd $1
    # missing lua library
    #cmake -DCMAKE_INSTALL_PREFIX=$PREFIX -DWITH_SCRIPTING=on
    cmake -DCMAKE_INSTALL_PREFIX=$PREFIX -DWITH_SCRIPTING=off
    make -j $(nproc)
    make install
    popd
}

for i in \
    libdsuid \
    libds485-core \
    libds485-netlib \
    libds485-client \
; do
    do_autoconf $i
done

do_cmake libdsm-api


# not ds485 stack related
do_autoconf libcommchannel
do_autoconf dss-websrc-mainline
do_make dsdata

