#!/bin/bash

. docker/env.sh

if [ ! -f dsscert.pem ]; then
    ./tools/create_cert.sh
    cp dsscert.pem $PREFIX/share/dss/data/dsscert.pem
fi

mkdir -p $PREFIX/share/dss/data/databases


./build-autoconf/build/dss --webroot=$PREFIX/share/dss-web/webroot \
     --prop:/config/subsystems/WebServer/listen=127.0.0.1:8088h,0.0.0.0:8081 \
     --prop:/config/subsystems/WebServer/trustedPort=8088 \
     --prop:/config/subsystems/DSBusInterface/connectionURI=tcp://localhost:8440 \
     --prop:/config/loglevel=1
