#/bin/sh

#exit on error
set -e

# Does docker require sudo?
if docker ps >/dev/null 2>/dev/null; then
    DOCKER="docker"
elif sudo docker ps >/dev/null 2>/dev/null; then
    DOCKER="sudo docker"
else
    echo "Docker not found. Please install: https://docs.docker.com/engine/installation/";
    exit;
fi

DKRIMG="$(basename $(dirname $(realpath $0)))"
VHOME="$(dirname $(realpath $0))/vhome"
echo image: $DKRIMG

USER=`id -un`
DS_OS_DIR="/home/${USER}/dSS/ds-os"

# Start new interactive container. Mount dss-oe folder inside.
$DOCKER run --rm -it \
    -v "${VHOME}:/home/${USER}":z \
    -v "${DS_OS_DIR}:${DS_OS_DIR}":z \
    --net=host \
    -e DISPLAY -v $HOME/.Xauthority:/home/${USER}/.Xauthority \
    -v $HOME/.ssh/known_hosts:/home/${USER}/.ssh/known_hosts \
    -e SSH_AUTH_SOCK=$SSH_AUTH_SOCK \
    -v "${SSH_AUTH_SOCK}:${SSH_AUTH_SOCK}":z \
    -e PS1="[\u@dkr-\h: \W]\$ " \
    -w ${DS_OS_DIR}/dss-mainline \
    ${DKRIMG} \
    bash
