DS_TESTS =

### ds

noinst_LIBRARIES += libds.a
libds_a_SOURCES = \
	../src/ds/clock.cpp \
	../src/ds/clock.h \
        ../src/ds/collection.cpp \
        ../src/ds/collection.h \
        ../src/ds/common.cpp \
        ../src/ds/common.h \
        ../src/ds/conf.cpp \
        ../src/ds/conf.h \
        ../src/ds/conf-mock.h \
        ../src/ds/date-time.cpp \
        ../src/ds/date-time.h \
        ../src/ds/elapsed.cpp \
        ../src/ds/elapsed.h \
        ../src/ds/enum.cpp \
        ../src/ds/enum.h \
        ../src/ds/exception.cpp \
        ../src/ds/exception.h \
        ../src/ds/http.cpp \
        ../src/ds/http.h \
        ../src/ds/json.cpp \
        ../src/ds/json.h \
        ../src/ds/latency-statistics.cpp \
        ../src/ds/latency-statistics.h \
        ../src/ds/log.cpp \
        ../src/ds/log.h \
        ../src/ds/promise.cpp \
        ../src/ds/promise.h \
        ../src/ds/random.cpp \
        ../src/ds/random.h \
        ../src/ds/reflect.cpp \
        ../src/ds/reflect.h \
        ../src/ds/ds-signal.cpp \
        ../src/ds/ds-signal.h \
        ../src/ds/str.cpp \
        ../src/ds/str.h \
        ../src/ds/stack-trace.cpp \
        ../src/ds/stack-trace.h \
        ../src/ds/system.cpp \
        ../src/ds/system.h \
        ../src/ds/sqlite3/ds-sqlite3.cpp \
        ../src/ds/sqlite3/ds-sqlite3.h \
        ../src/ds/tracing.cpp \
        ../src/ds/tracing.h
libds_a_CPPFLAGS = \
        -DDS_SYSCONFDIR='"$(sysconfdir)"' \
        -DDS_DATADIR='"$(datadir)"' \
        $(AM_CPPFLAGS) \
        $(BOOST_CPPFLAGS)
libds_a_LIB = \
        libds.a \
        $(BOOST_SYSTEM_LIB) \
        $(BOOST_CHRONO_LIB) \
        $(BOOST_FILESYSTEM_LIB) \
        -lpthread \
        -ljson-c

check_LIBRARIES += libds-catch-main.a
libds_catch_main_a_SOURCES = \
        ../src/ds/catch/main.cpp
libds_catch_main_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_catch_main_a_LIB = \
        libds-catch-main.a

DS_TESTS += ds-test
ds_test_SOURCES = \
        ../src/ds/clock-test.cpp \
        ../src/ds/collection-test.cpp \
        ../src/ds/common-test.cpp \
        ../src/ds/conf-test.cpp \
        ../src/ds/date-time-test.cpp \
        ../src/ds/enum-test.cpp \
        ../src/ds/exception-test.cpp \
        ../src/ds/http-test.cpp \
        ../src/ds/json-test.cpp \
        ../src/ds/latency-statistics-test.cpp \
        ../src/ds/log-test.cpp \
        ../src/ds/ds-signal-test.cpp \
        ../src/ds/str-test.cpp \
        ../src/ds/promise-test.cpp \
        ../src/ds/random-test.cpp \
        ../src/ds/reflect-test.cpp \
        ../src/ds/stack-trace-test.cpp \
        ../src/ds/system-test.cpp \
        ../src/ds/tracing-test.cpp \
        ../src/ds/sqlite3/ds-sqlite3-test.cpp
ds_test_CPPFLAGS = \
        -DDS_SRC_DIR='"$(abs_srcdir)/../src/ds/"' \
        $(libds_a_CPPFLAGS)
ds_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_a_LIB) \
        $(SQLITE3_LIBS)

### ds-crypt

noinst_LIBRARIES += libds-crypt.a
libds_crypt_a_SOURCES = \
        ../src/ds-crypt/digest.cpp\
        ../src/ds-crypt/digest.h
libds_crypt_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_crypt_a_LIB = \
        libds-crypt.a \
        -lcrypto \
        $(libds_a_LIB)

DS_TESTS += ds-crypt-test
ds_crypt_test_SOURCES = \
        ../src/ds-crypt/digest-test.cpp
ds_crypt_test_CPPFLAGS = \
        $(libds_crypt_a_CPPFLAGS)
ds_crypt_test_LDADD = \
        $(libds_crypt_a_LIB) \
        $(libds_catch_main_a_LIB)


### ds-locale

noinst_LIBRARIES += libds-locale.a
libds_locale_a_SOURCES = \
        ../src/ds/locale/backend.cpp \
        ../src/ds/locale/backend.h \
        ../src/ds/locale/ds-locale.cpp \
        ../src/ds/locale/ds-locale.h \
        ../src/ds/locale/messages.cpp \
        ../src/ds/locale/messages.h \
        ../src/ds/locale/test.cpp
libds_locale_a_CPPFLAGS = \
        -DDS_LOCALEDIR='"$(localedir)"' \
        $(libds_a_CPPFLAGS)
libds_locale_a_LIB = \
        libds-locale.a \
        $(BOOST_LOCALE_LIB) \
        $(libds_a_LIB)

DS_TESTS += ds-locale-test
ds_locale_test_SOURCES = \
        ../src/ds/locale/backend-test.cpp \
        ../src/ds/locale/ds-locale-test.cpp \
        ../src/ds/locale/messages-test.cpp
ds_locale_test_CPPFLAGS = \
        -DDS_LOCALE_SRC_DIR='"$(abs_srcdir)/../src/ds/locale/"' \
        $(libds_locale_a_CPPFLAGS)
ds_locale_test_LDADD = \
        $(libds_locale_a_LIB) \
        $(libds_catch_main_a_LIB)


### ds-asio

noinst_LIBRARIES += libds-asio.a
libds_asio_a_SOURCES = \
	../src/ds/asio/abortable.cpp \
	../src/ds/asio/abortable.h \
	../src/ds/asio/back-off.cpp \
	../src/ds/asio/back-off.h\
	../src/ds/asio/io-service.cpp \
	../src/ds/asio/io-service.h \
	../src/ds/asio/latency-watchdog.cpp \
	../src/ds/asio/latency-watchdog.h \
	../src/ds/asio/loop-impl.cpp \
	../src/ds/asio/loop-impl.h \
	../src/ds/asio/loop.cpp \
	../src/ds/asio/loop.h \
	../src/ds/asio/moderation-timer.cpp \
	../src/ds/asio/moderation-timer.h \
	../src/ds/asio/state-poller.cpp \
	../src/ds/asio/state-poller.h \
	../src/ds/asio/reconnect-timer.cpp \
	../src/ds/asio/reconnect-timer.h \
	../src/ds/asio/reconnecting-socket.h \
	../src/ds/asio/reconnecting-socket.cpp \
	../src/ds/asio/resource.cpp \
	../src/ds/asio/resource.h \
	../src/ds/asio/retryer.cpp \
	../src/ds/asio/retryer.h \
	../src/ds/asio/timer.cpp \
	../src/ds/asio/timer.h \
	../src/ds/asio/thread-pool.cpp \
	../src/ds/asio/thread-pool.h \
	../src/ds/asio/watchdog.cpp \
	../src/ds/asio/watchdog.h
libds_asio_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_asio_a_LIB = \
        libds-asio.a \
        $(libds_a_LIB) \
        $(libds_crypt_a_LIB)

DS_TESTS += ds-asio-test
ds_asio_test_SOURCES = \
        ../src/ds/asio/abortable-test.cpp \
	../src/ds/asio/back-off-test.cpp \
        ../src/ds/asio/io-service-test.cpp \
	../src/ds/asio/latency-watchdog-test.cpp \
	../src/ds/asio/loop-test.cpp \
	../src/ds/asio/moderation-timer-test.cpp \
        ../src/ds/asio/reconnect-timer-test.cpp \
	../src/ds/asio/state-poller-test.cpp \
	../src/ds/asio/resource-test.cpp \
	../src/ds/asio/retryer-test.cpp \
        ../src/ds/asio/timer-test.cpp \
	../src/ds/asio/thread-pool-test.cpp \
        ../src/ds/asio/watchdog-test.cpp
ds_asio_test_CPPFLAGS = \
        $(libds_asio_a_CPPFLAGS)
ds_asio_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_asio_a_LIB)


### ds-api

noinst_LIBRARIES += libds-api.a
libds_api_a_SOURCES = \
	../src/ds-api/event.cpp \
	../src/ds-api/event.h \
	../src/ds-api/rest.cpp \
	../src/ds-api/rest.h \
	../src/ds-api/route-segments.cpp \
	../src/ds-api/route-segments.h \
	../src/ds-api/service.cpp \
	../src/ds-api/service.h \
	../src/ds-api/text.cpp \
	../src/ds-api/text.h
libds_api_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_api_a_LIB = \
        libds-api.a \
        $(libds_a_LIB)

DS_TESTS += ds-api-test
ds_api_test_SOURCES = \
	../src/ds-api/route-segments-test.cpp \
	../src/ds-api/service-test.cpp
ds_api_test_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
ds_api_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_api_a_LIB)

### ds-model

noinst_LIBRARIES += libds-model.a
libds_model_a_SOURCES = \
	../src/ds-model/apartment-api.cpp \
	../src/ds-model/apartment-api.h \
	../src/ds-model/model.cpp \
	../src/ds-model/model.h \
	../src/ds-model/scenarios.cpp \
	../src/ds-model/scenarios.h
libds_model_a_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
libds_model_a_LIB = \
        libds-model.a \
        $(libds_api_a_LIB)

DS_TESTS += ds-model-test
ds_model_test_SOURCES = \
	../src/ds-model/apartment-api-test.cpp \
	../src/ds-model/model-test.cpp \
	../src/ds-model/scenarios-test.cpp
ds_model_test_CPPFLAGS = \
        $(libds_model_a_CPPFLAGS)
ds_model_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_model_a_LIB)

### ds-connector

noinst_LIBRARIES += libds-connector.a
libds_connector_a_SOURCES = \
	../src/ds-connector/backend-stream-client.cpp \
	../src/ds-connector/backend-stream-client.h \
	../src/ds-connector/client-bus.cpp \
	../src/ds-connector/client-bus.h \
	../src/ds-connector/http-server.cpp \
	../src/ds-connector/http-server.h \
	../src/ds-connector/protocol.cpp \
	../src/ds-connector/protocol.h \
	../src/ds-connector/stream.cpp \
	../src/ds-connector/stream.h \
	../src/ds-connector/subscriptions.cpp \
	../src/ds-connector/subscriptions.h \
	../src/ds-connector/wss-client.cpp \
	../src/ds-connector/wss-client.h
libds_connector_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS) \
	$(LIBDSUID_CFLAGS) \
	$(BOOST_BEAST_CFLAGS)
libds_connector_a_LIB = \
        libds-connector.a \
        -lssl -lcrypto \
        $(libds_a_LIB) \
        $(libds_asio_a_LIB) \
        $(libds_api_a_LIB) \
        $(BOOST_BEAST_LIBS) \
        $(ATOMIC_LDFLAGS)

DS_TESTS += ds-connector-test
ds_connector_test_SOURCES = \
	../src/ds-connector/stream-mock.h \
	../src/ds-connector/client-bus-test.cpp \
	../src/ds-connector/subscriptions-test.cpp \
	../src/ds-connector/wss-client-test.cpp
ds_connector_test_CPPFLAGS = \
        $(libds_connector_a_CPPFLAGS)
ds_connector_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_connector_a_LIB)

bin_PROGRAMS += ds-connector-cat
ds_connector_cat_SOURCES = \
	../src/ds-connector/cat-main.cpp
ds_connector_cat_CPPFLAGS = \
        $(libds_a_CPPFLAGS) \
	$(LIBDSUID_CFLAGS)
ds_connector_cat_LDADD = \
        $(libds_connector_a_LIB) \
        $(libds_api_a_LIB)

### ds integration

check_PROGRAMS += $(DS_TESTS)
TESTS += $(DS_TESTS)

### dss

libdsscore_a_SOURCES =  \
	../src/view/device-config.capnp.dss.cpp \
	../src/view/device-config.capnp.dss.h \
	../src/view/umr200-config.cpp \
	../src/view/umr200-config.h \
	../src/backend-vdcs.cpp \
	../src/backend-vdcs.h \
	../src/base.cpp \
	../src/base.h \
	../src/bus.cpp \
	../src/bus.h \
	../src/bonjour.cpp \
	../src/bonjour.h \
	../src/businterface.cpp \
	../src/businterface.h \
	../src/businterface-mock.h \
	../src/comm-channel.cpp \
	../src/comm-channel.h \
	../src/controller-statuses.cpp \
	../src/controller-statuses.h \
	../src/datetools.cpp \
	../src/datetools.h \
	../src/defaultbuseventsink.cpp \
	../src/defaultbuseventsink.h \
	../src/device-info.cpp \
	../src/device-info.h \
	../src/ds485/dsactionrequest.cpp \
	../src/ds485/dsactionrequest.h \
	../src/ds485/dsbusinterface.cpp \
	../src/ds485/dsbusinterface.h \
	../src/ds485/dsbusinterfaceobj.cpp \
	../src/ds485/dsbusinterfaceobj.h \
	../src/ds485/dsmeteringbusinterface.cpp \
	../src/ds485/dsmeteringbusinterface.h \
	../src/ds485types.cpp \
	../src/ds485types.h \
	../src/ds485-device.cpp \
	../src/ds485-device.h \
	../src/ds485-query.cpp \
	../src/ds485-query.h \
	../src/ds485-modify.cpp \
	../src/ds485-modify.h \
	../src/dsa-http-client.cpp \
	../src/dsa-http-client.h \
	../src/dss.cpp \
	../src/dss.h \
	../src/dssfwd.h \
	../src/event.cpp \
	../src/event.h \
	../src/event-mock.h \
	../src/event/event_create.cpp \
	../src/event/event_create.h \
	../src/event/event_fields.cpp \
	../src/event/event_fields.h \
	../src/eventcollector.cpp \
	../src/eventcollector.h \
	../src/eventinterpreterplugins.cpp \
	../src/eventinterpreterplugins.h \
	../src/eventinterpretersystemplugins.cpp \
	../src/eventinterpretersystemplugins.h \
	../src/eventsubscriptionsession.cpp \
	../src/eventsubscriptionsession.h \
	../src/exception.cpp \
	../src/exception.h \
	../src/expatparser.cpp \
	../src/expatparser.h \
	../src/handler/action-execute.cpp \
	../src/handler/action-execute.h \
	../src/handler/event-logger.cpp \
	../src/handler/event-logger.h \
	../src/handler/system_handlers.cpp \
	../src/handler/system_handlers.h \
	../src/handler/system_states.cpp \
	../src/handler/system_states.h \
	../src/handler/system_triggers.cpp \
	../src/handler/system_triggers.h \
	../src/hasher.cpp \
	../src/hasher.h \
	../src/heatingregistering.cpp \
	../src/heatingregistering.h \
	../src/http_client.cpp \
	../src/http_client.h \
	../src/internaleventrelaytarget.h \
	../src/logger.cpp \
	../src/logger.h \
	../src/metering/metering.cpp \
	../src/metering/metering.h \
	../src/model/action.h \
	../src/model-features.cpp \
	../src/model-features.h \
	../src/model/addressablemodelitem.cpp \
	../src/model/addressablemodelitem.h \
	../src/model/apartment.cpp \
	../src/model/apartment.h \
	../src/model/autoclustermaintenance.cpp \
	../src/model/autoclustermaintenance.h \
	../src/model/behavior.cpp \
	../src/model/behavior.h \
	../src/model/busscanner.cpp \
	../src/model/busscanner.h \
	../src/model/cluster.cpp \
	../src/model/cluster.h \
	../src/model/status-field.cpp \
	../src/model/status-field.h \
	../src/model/status.h \
	../src/model/status.cpp \
	../src/model/data_types.cpp \
	../src/model/data_types.h \
	../src/model/device.cpp \
	../src/model/device.h \
	../src/model/device-data.cpp \
	../src/model/device-data.h \
	../src/model/devicecontainer.cpp \
	../src/model/devicecontainer.h \
	../src/model/deviceinterface.cpp \
	../src/model/deviceinterface.h \
	../src/model/devicereference.cpp \
	../src/model/devicereference.h \
	../src/model/dsmeter.cpp \
	../src/model/dsmeter.h \
	../src/model/group.cpp \
	../src/model/group.h \
	../src/model/modelconst.cpp \
	../src/model/modelconst.h \
	../src/model/modelevent.cpp \
	../src/model/modelevent.h \
	../src/model/modelmaintenance.cpp \
	../src/model/modelmaintenance.h \
	../src/model/modelpersistence.cpp \
	../src/model/modelpersistence.h \
	../src/model/nonaddressablemodelitem.cpp \
	../src/model/nonaddressablemodelitem.h \
	../src/model/physicalmodelitem.cpp \
	../src/model/physicalmodelitem.h \
	../src/model/scenehelper.cpp \
	../src/model/scenehelper.h \
	../src/model/set.cpp \
	../src/model/set.h \
	../src/model/setsplitter.cpp \
	../src/model/setsplitter.h \
	../src/model/state.cpp \
	../src/model/state.h \
	../src/model/zone.cpp \
	../src/model/zone.h \
	../src/model/floor.h \
	../src/model/floor.cpp \
	../src/monitor_tasks.cpp \
	../src/monitor_tasks.h \
	../src/property-parser.cpp \
	../src/property-parser.h \
	../src/propertyquery.cpp \
	../src/propertyquery.h \
	../src/propertysystem.cpp \
	../src/propertysystem.h \
	../src/propertysystem_common_paths.cpp \
	../src/propertysystem_common_paths.h \
	../src/protobufjson.cpp \
	../src/protobufjson.h \
	../src/reregister-devices.cpp \
	../src/reregister-devices.h \
	../src/sceneaccess.cpp \
	../src/sceneaccess.h \
	../src/scripting/jscluster.cpp \
	../src/scripting/jscluster.h \
	../src/scripting/jscurl-constants.h \
	../src/scripting/jscurl-options.h \
	../src/scripting/jscurl.cpp \
	../src/scripting/jscurl.h \
	../src/scripting/jsdatabase.cpp \
	../src/scripting/jsdatabase.h \
	../src/scripting/jsevent.cpp \
	../src/scripting/jsevent.h \
	../src/scripting/jshandler.cpp \
	../src/scripting/jshandler.h \
	../src/scripting/jslogger.cpp \
	../src/scripting/jslogger.h \
	../src/scripting/jsmetering.cpp \
	../src/scripting/jsmetering.h \
	../src/scripting/jsmodel.cpp \
	../src/scripting/jsmodel.h \
	../src/scripting/jsproperty.cpp \
	../src/scripting/jsproperty.h \
	../src/scripting/jswebservice.cpp \
	../src/scripting/jswebservice.h \
	../src/scripting/scriptobject.cpp \
	../src/scripting/scriptobject.h \
	../src/security/privilege.cpp \
	../src/security/privilege.h \
	../src/security/security.cpp \
	../src/security/security.h \
	../src/security/user.cpp \
	../src/security/user.h \
	../src/sensor_data_uploader.cpp \
	../src/sensor_data_uploader.h \
	../src/session.cpp \
	../src/session.h \
	../src/sessionmanager.cpp \
	../src/sessionmanager.h \
	../src/setbuilder.cpp \
	../src/setbuilder.h \
	../src/sqlite3_wrapper.cc \
	../src/sqlite3_wrapper.h \
	../src/storagetools.cpp \
	../src/storagetools.h \
	../src/stringconverter.cpp \
	../src/stringconverter.h \
	../src/structuremanipulator.cpp \
	../src/structuremanipulator.h \
	../src/subscription.cpp \
	../src/subscription.h \
	../src/subscription_profiler.cpp \
	../src/subscription_profiler.h \
	../src/subsystem.cpp \
	../src/subsystem.h \
	../src/syncevent.cpp \
	../src/syncevent.h \
	../src/systemcondition.cpp \
	../src/systemcondition.h \
	../src/taskprocessor.cpp \
	../src/taskprocessor.h \
	../src/test-device-presence.cpp \
	../src/test-device-presence.h \
	../src/thread.h \
	../src/util.cpp \
	../src/util.h \
	../src/vdc.cpp \
	../src/vdc.h \
	../src/vdc-connection.cpp \
	../src/vdc-connection.h \
	../src/vdc-db.cpp \
	../src/vdc-db.h \
	../src/vdc-db-mock.h \
	../src/vdc-element-reader.cpp \
	../src/vdc-element-reader.h \
	../src/vdc-token.cpp \
	../src/vdc-token.h \
	../src/watchdog.cpp \
	../src/watchdog.h \
	../src/web/handler/apartmentrequesthandler.cpp \
	../src/web/handler/apartmentrequesthandler.h \
	../src/web/handler/circuitrequesthandler.cpp \
	../src/web/handler/circuitrequesthandler.h \
	../src/web/handler/databaserequesthandler.cc \
	../src/web/handler/databaserequesthandler.h \
	../src/web/handler/deviceinterfacerequesthandler.cpp \
	../src/web/handler/deviceinterfacerequesthandler.h \
	../src/web/handler/devicerequesthandler.cpp \
	../src/web/handler/devicerequesthandler.h \
	../src/web/handler/eventrequesthandler.cpp \
	../src/web/handler/eventrequesthandler.h \
	../src/web/handler/internalrequesthandler.cpp \
	../src/web/handler/internalrequesthandler.h \
	../src/web/handler/jsonhelper.cpp \
	../src/web/handler/jsonhelper.h \
	../src/web/handler/meteringrequesthandler.cpp \
	../src/web/handler/meteringrequesthandler.h \
	../src/web/handler/propertyrequesthandler.cpp \
	../src/web/handler/propertyrequesthandler.h \
	../src/web/handler/setrequesthandler.cpp \
	../src/web/handler/setrequesthandler.h \
	../src/web/handler/staterequesthandler.cpp \
	../src/web/handler/staterequesthandler.h \
	../src/web/handler/structurerequesthandler.cpp \
	../src/web/handler/structurerequesthandler.h \
	../src/web/handler/subscriptionrequesthandler.cpp \
	../src/web/handler/subscriptionrequesthandler.h \
	../src/web/handler/systemrequesthandler.cpp \
	../src/web/handler/systemrequesthandler.h \
	../src/web/handler/zonerequesthandler.cpp \
	../src/web/handler/zonerequesthandler.h \
	../src/web/restful.cpp \
	../src/web/restful.h \
	../src/web/webrequests.cpp \
	../src/web/webrequests.h \
	../src/web/webserver.cpp \
	../src/web/webserver.h \
	../src/web/websocket/connection.cpp \
	../src/web/websocket/connection.h \
	../src/web/websocket/eventobserver.h \
	../src/web/websocket/identifydevice.cpp \
	../src/web/websocket/identifydevice.h \
	../src/web/websocket/jsonapiserver.cpp \
	../src/web/websocket/jsonapiserver.h \
	../src/web/websocket/message.cpp \
	../src/web/websocket/message.h \
	../src/web/websocket/observerbuilder.cpp \
	../src/web/websocket/observerbuilder.h \
	../src/web/websocket/simpleserver.cpp \
	../src/web/websocket/simpleserver.h \
	../src/webservice_api.cpp \
	../src/webservice_api.h \
	../src/webservice_connection.cpp \
	../src/webservice_connection.h \
	../src/ds-model.cpp \
	../src/ds-model.h \
	../src/ds-scenarios.cpp \
	../src/ds-scenarios.h \
	../src/cache/cache-db.cpp \
	../src/cache/cache-db.h \
	../src/cache/device-cache.h \
	../src/cache/apartment-proxy.h \
	../src/cache/apartment-proxy.cpp \
	../src/hal/hardware-abstraction.cpp \
	../src/hal/hardware-abstraction.h \
	../src/hal/hal-device.cpp \
	../src/hal/light-device.cpp \
	../src/hal/shade-device.cpp \
	../src/hal/joker-device.cpp \
	../src/cache/cache-updater.h \
	../src/cache/cache-updater.cpp

libcivetweb_a_SOURCES = \
	../external/civetweb/civetweb.c \
	../external/civetweb/civetweb.h \
	../external/civetweb/civetweb-ds-log.cpp \
	../external/civetweb/civetweb-ds-log.h \
	../external/civetweb/file_ops.inl \
	../external/civetweb/handle_form.inl \
	../external/civetweb/sha1.inl \
	../external/civetweb/md5.inl

libunix_a_SOURCES = \
	../unix/systeminfo.cpp \
	../unix/systeminfo.h \
	../unix/thread.cpp

dsstests_SOURCES = \
	../tests/000_dss_instance_fixture_test.cpp \
	../tests/apartment_xml_tests.cpp \
	../tests/basetests.cpp \
	../tests/circuitrequesthandlertest.cpp \
	../tests/datetoolstests.cpp \
	../tests/deviceinterfacerequesthandlertest.cpp \
	../tests/devicerequesthandlertest.cpp \
	../tests/zonerequesthandlertest.cpp \
	../tests/devicetests.cpp \
	../tests/dsuidtests.cpp \
	../tests/event_systemcondition_test.cpp \
	../tests/event_trigger_tests.cpp \
	../tests/eventrequesthandlertest.cpp \
	../tests/eventtests.cpp \
	../tests/iconvtests.cpp \
	../tests/jsclustertests.cpp \
	../tests/jsdatabase.cpp \
	../tests/jshandlertests.cpp \
	../tests/jsloggertests.cpp \
	../tests/jsontests.cpp \
	../tests/jsproperty.cpp \
	../tests/meteringtests.cpp \
	../tests/model-autocluster_tests.cpp \
	../tests/model-cluster_tests.cpp \
	../tests/model-mainloop_tests.cpp \
	../tests/modeljstests.cpp \
	../tests/modeltests.cpp \
	../tests/property_xmlparser_tests.cpp \
	../tests/propertysystemtests.cpp \
	../tests/restfulapitests.cpp \
	../tests/scriptstest.cpp \
	../tests/securitytests.cpp \
	../tests/sensor_data_uploader.cpp \
	../tests/sensorconversiontest.cpp \
	../tests/sqlite3_wrapper.cpp \
	../tests/statetests.cpp \
	../tests/systeminfo_tests.cpp \
	../tests/testrunner.cpp \
	../tests/util/ds485-bus-mockups.h \
	../tests/util/dss_instance_fixture.cpp \
	../tests/util/dss_instance_fixture.h \
	../tests/util/modelmaintenance-mockup.h \
	../tests/vdc-db.cpp \
	../tests/webfixture.h \
	../tests/webserver.cpp \
	../tests/webservice_api_tests.cpp \
	../tests/zone_tests.cpp


bin_PROGRAMS += dss

EXTRA_DIST +=	../src/messages/messaging.proto \
				../src/messages/device-scene-table-update.proto \
				../src/messages/vdc-messages.proto \
				../src/messages/vdcapi.proto

CLEANFILES += \
			../src/messages/messaging.pb.h \
			../src/messages/messaging.pb.cc \
			../src/messages/device-scene-table-update.pb.h \
			../src/messages/device-scene-table-update.pb.cc \
			../src/messages/vdc-messages.pb.h \
	        ../src/messages/vdc-messages.pb.cc \
			../src/messages/vdcapi.pb.h \
	        ../src/messages/vdcapi.pb.cc


BUILT_SOURCES += \
			../src/messages/messaging.pb.h \
			../src/messages/messaging.pb.cc \
			../src/messages/device-scene-table-update.pb.h \
			../src/messages/device-scene-table-update.pb.cc \
			../src/messages/vdc-messages.pb.h \
			../src/messages/vdc-messages.pb.cc \
			../src/messages/vdcapi.pb.h \
	        ../src/messages/vdcapi.pb.cc

noinst_LIBRARIES += libdsscore.a libcivetweb.a libunix.a libprotomessages.a

nodist_libprotomessages_a_SOURCES = \
			../src/messages/messaging.pb.h \
			../src/messages/messaging.pb.cc \
			../src/messages/device-scene-table-update.pb.h \
			../src/messages/device-scene-table-update.pb.cc \
			../src/messages/vdc-messages.pb.h \
			../src/messages/vdc-messages.pb.cc \
			../src/messages/vdcapi.pb.h \
	        ../src/messages/vdcapi.pb.cc

libprotomessages_a_CXXFLAGS = \
			-I$(top_srcdir) \
			-I$(top_builddir)/src \
			-Wno-misleading-indentation \
			$(LIBPROTOBUF_CFLAGS)

libdsscore_a_CXXFLAGS = \
			-I$(top_srcdir) \
			-I$(top_srcdir)/src \
			-I$(top_builddir)/src \
			$(JSONC_CFLAGS) \
			$(JS_CFLAGS) \
			$(ICAL_CFLAGS) \
			$(LIBDSM_API_CFLAGS) \
			$(LIBXML2_CFLAGS) \
			$(OPENSSL_CFLAGS) \
			$(AVAHI_CFLAGS) \
			$(CURL_CFLAGS) \
			$(LIBRRD_CFLAGS) \
			$(EXPAT_CFLAGS) \
			$(GCOV_CFLAGS) \
			$(OSSP_UUID_CFLAGS) \
			$(BOOST_CPPFLAGS) \
			$(LIBPROTOBUF_CFLAGS) \
			$(LIBCOMMCHANNEL_CFLAGS) \
			$(LIBDSUID_CFLAGS) \
			$(libds_a_CPPFLAGS)

libdsscore_a_LIB = \
        $(libds_asio_a_LIB) \
        $(libds_locale_a_LIB) \
        $(libds_api_a_LIB) \
        $(libds_model_a_LIB)


dss_SOURCES = ../src/main.cpp

dss_CXXFLAGS = \
			-I$(top_srcdir)/src \
			-I$(top_builddir)/src \
			$(LIBXML2_CFLAGS) \
			$(GCOV_CFLAGS) \
			$(ICAL_CFLAGS) \
            $(LIBPROTOBUF_CFLAGS) \
            $(LIBCOMMCHANNEL_CFLAGS) \
			$(LIBDSUID_CFLAGS) \
			$(OSSP_UUID_CFLAGS) \
			$(BOOST_CPPFLAGS) \
			$(SQLITE3_CFLAGS)

COMMON_LDFLAGS = libdsscore.a libunix.a libcivetweb.a libprotomessages.a \
      $(LIBDSM_API_LDFLAGS) \
      $(LIBDSM_API_LIBS) \
      $(BOOST_LDFLAGS) \
      $(JS_LIBS) \
      $(ICAL_LIBS) \
      $(LIBXML2_LIBS) \
      $(OPENSSL_LIBS) \
      $(AVAHI_LIBS) \
      $(CURL_LIBS) \
      $(LIBRRD_LIBS) \
      $(EXPAT_LIBS) \
      $(GCOV_LIBS) \
      $(LIBTCMALLOC_LIBS) \
      $(JSONC_LIBS) \
      $(LIBPROTOBUF_LIBS) \
      $(LIBCOMMCHANNEL_LIBS) \
      $(LIBDSUID_LIBS) \
      $(OSSP_UUID_LIBS) \
      $(LTLIBICONV) \
      $(BOOST_FILESYSTEM_LIB) \
      $(BOOST_PROGRAM_OPTIONS_LIB) \
      $(BOOST_SYSTEM_LIB) \
      $(BOOST_THREAD_LIB) \
      $(BOOST_CHRONO_LIB) \
      $(SQLITE3_LIBS) \
      $(libds_connector_a_LIB) \
      $(libdsscore_a_LIB)

dss_LDADD = $(COMMON_LDFLAGS)

../src/dss.cpp: build_info.h


TESTS += dss-test
check_PROGRAMS += dss-test
dss_test_SOURCES = \
	../src/dss_instance_fixture.cpp \
	../src/datetools-test.cpp \
	../src/backend-vdcs-test.cpp \
	../src/ds-model-test.cpp \
	../src/ds-scenarios-test.cpp \
	../src/device-info-test.cpp \
	../src/vdc-element-reader-test.cpp \
	../src/scripting/modeljs-test.cpp \
  ../src/dsm-api-mock.cpp \
  ../src/ds485-query-test.cpp \
  ../src/cache/apartment-status-test.cpp \
  ../src/cache/cache-db-test.cpp \
  ../src/cache/device-cache-test.cpp \
  ../src/cache/apartment-proxy-test.cpp \
  ../src/hal/hardware-abstraction-test.cpp \
  ../src/hal/light-device-multi-channel-test.cpp \
  ../src/hal/light-device-state-machine-test.cpp \
  ../src/hal/shade-device-state-machine-test.cpp \
  ../src/hal/joker-device-state-machine-test.cpp \
  ../src/cache/cache-updater-test.cpp \
  ../src/model/modelmaintenance-test.cpp \
  ../src/model/device-test.cpp \
  ../src/model/group-test.cpp \
  ../src/model/cluster-test.cpp \
	../src/web/handler/structurerequesthandler-test.cpp

dss_test_CPPFLAGS = \
        $(libdsscore_a_CXXFLAGS) \
        -DABS_SRCDIR=\"@abs_top_srcdir@\" \
        -DABS_BUILDDIR=\"@abs_top_builddir@\"
dss_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(COMMON_LDFLAGS) \
        -lds485-client -ldsuid


../src/comm-channel.h: ../src/messages/messaging.pb.h
../src/comm-channel.cpp: ../src/messages/device-scene-table-update.pb.h


../src/vdc-connection.h: ../src/messages/vdc-messages.pb.h
%.pb.cc %.pb.h: %.proto
	$(MKDIR_P) ../src/messages
	protoc -I$(top_srcdir)/src/messages --cpp_out=../src/messages $(top_srcdir)/src/messages/$(<F)

tx-update-sources-local:
	TOP_SRCDIR=$(top_srcdir) $(top_srcdir)/src/xgettext.sh $(dss_SOURCES) $(libdsscore_a_SOURCES)
