/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <backend-vdcs.h>
#include <ds/json.h>
#include <dsa-http-client.h>

namespace dss {

struct ControllerStatus {
  enum struct Code { off, ready, error };
  Code code;
  std::string message;
};

ds::Enum<ControllerStatus::Code> dsEnum(ControllerStatus::Code);
std::ostream& operator<<(std::ostream& stream, ControllerStatus::Code x);

typedef std::vector<std::pair<std::string, ControllerStatus>> ControllerStatuses;

ControllerStatuses controllerStatuses(const std::locale& locale, DsaHttpClient& dsa, BackendVdcs& backendVdcs);

} // namespace dss

DS_REFLECT_STRUCT((dss), ControllerStatus, (code)(message));
