/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <ds/json.h>
#include <boost/noncopyable.hpp>
#include <boost/serialization/strong_typedef.hpp>

namespace dsApi {

BOOST_STRONG_TYPEDEF(std::string, EventType);
struct Event {
  EventType type;
  std::string path;
  ds::JsonFragment data;
};

/// EventsSink pushes (routes) events to subscribers
struct EventsSink : public boost::noncopyable {
  virtual ~EventsSink() {}

  // thread safe
  virtual void event(dsApi::Event&&) = 0;

  // possible future: options to watch active, added, removed subscriptions
};

} // namespace dsApi

DS_JSON_DECLARE_STRUCT((dsApi), Event, (type)(path)(data));
