#pragma once

#include <map>
#include <vector>

namespace dsApi {

enum class HttpMethod;
enum class PatchOperationType;

using HttpHeaders = std::map<std::string, std::vector<std::string>>;
struct HttpArgs;
using RouteHttpArgs = std::map<std::string, std::string>;
struct HttpRequest;
struct HttpResult;
class AsyncCallee;
struct Error;
struct Document;

template <class Id, class Attributes>
struct ResourceData;

template <class Id, class Attributes, class Included>
struct ResourceDataWithIncluded;

template <class Id, class... Alternatives>
struct VariantResourceData;

struct PatchOperation;
struct PatchRequest;

} // namespace dsApi
