/*
    Copyright (c) 2018  digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/
#pragma once

#include <ds/ds-signal-mock.h>
#include <trompeloeil.hpp>
#include "client-bus.h"
#include "protocol.h"

namespace dsConnector {

class ClientBusHookMock : public trompeloeil::mock_interface<ClientBusHook> {
public:
  IMPLEMENT_MOCK0(authenticate);
  IMPLEMENT_MOCK2(asyncInvoke);
};

class ClientBusMock : public trompeloeil::mock_interface<ClientBus> {
public:
  IMPLEMENT_CONST_MOCK0(isConnected);
  IMPLEMENT_MOCK1(setActive);
  IMPLEMENT_MOCK1(event);
  IMPLEMENT_MOCK2(asyncInvoke);
};

DS_SLOT_MOCK1(BusIsConnectedChangedMock, bool);

} // namespace dsConnector
