#include <ds-api/rest.h>
#include <boost/asio/io_context.hpp>
#include <boost/asio/ip/tcp.hpp>
#include <boost/beast/http/message.hpp>
#include <boost/beast/http/string_body.hpp>
#include <functional>

namespace dsConnector {

class HttpServer {
public:
  virtual ~HttpServer() = default;
  virtual boost::asio::ip::tcp::endpoint localEndpoint() const = 0;
};

std::unique_ptr<HttpServer> makeHttpServer(boost::asio::io_context &, const boost::asio::ip::tcp::endpoint &,
                                           dsApi::AsyncCallee &);

} // namespace dsConnector
