/*
    Copyright (c) 2018  digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/
#pragma once

#include <trompeloeil.hpp>
#include "stream.h"

namespace dsConnector {

class StreamMock : public trompeloeil::mock_interface<Stream> {
public:
  ~StreamMock() {
    if (m_onDestroyed) {
      m_onDestroyed();
    }
  }
  void setOnDestroyed(std::function<void()> &&x) { m_onDestroyed = std::move(x); }

  IMPLEMENT_MOCK2(asyncWrite);
  IMPLEMENT_MOCK1(asyncRead);
  std::string str() const override { return "streamMock"; }

private:
  std::function<void()> m_onDestroyed{};
};

class StreamClientMock : public trompeloeil::mock_interface<StreamClient> {
public:
  IMPLEMENT_MOCK1(asyncConnect);
  std::string str() const override { return "streamClientMock"; }
};

} // namespace dsConnector
