/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>
#include "apartment-api.h"

namespace dsModel {

class ApartmentApiMock : public trompeloeil::mock_interface<ApartmentApi> {
public:
  IMPLEMENT_MOCK0(scenarios);
  IMPLEMENT_CONST_MOCK0(scenarios);

  IMPLEMENT_CONST_MOCK1(zone);
  IMPLEMENT_CONST_MOCK0(zones);
  IMPLEMENT_MOCK2(setZoneName);
  IMPLEMENT_CONST_MOCK1(zoneStatus);
  IMPLEMENT_CONST_MOCK0(zoneStatuses);

  IMPLEMENT_CONST_MOCK1(cluster);
  IMPLEMENT_CONST_MOCK0(clusters);
  IMPLEMENT_CONST_MOCK1(clusterStatus);
  IMPLEMENT_CONST_MOCK0(clusterStatuses);
  IMPLEMENT_MOCK2(setClusterName);

  IMPLEMENT_CONST_MOCK1(device);
  IMPLEMENT_CONST_MOCK0(devices);
  IMPLEMENT_CONST_MOCK1(deviceStatus);
  IMPLEMENT_CONST_MOCK0(deviceStatuses);
  IMPLEMENT_MOCK2(setOutputValue);

  IMPLEMENT_CONST_MOCK1(submodule);
  IMPLEMENT_CONST_MOCK0(submodules);

  IMPLEMENT_CONST_MOCK1(functionBlock);
  IMPLEMENT_CONST_MOCK0(functionBlocks);

  IMPLEMENT_CONST_MOCK0(apartmentAccessStatus);
  IMPLEMENT_CONST_MOCK0(apartmentUserStatus);
  IMPLEMENT_CONST_MOCK0(apartmentSecurity);
  IMPLEMENT_MOCK1(setApartmentAlarm1Name);
  IMPLEMENT_MOCK1(setApartmentAlarm2Name);
  IMPLEMENT_MOCK1(setApartmentAlarm3Name);
  IMPLEMENT_MOCK1(setApartmentAlarm4Name);
  IMPLEMENT_CONST_MOCK0(apartmentSecurityStatus);
  IMPLEMENT_CONST_MOCK0(apartmentTemperatureStatus);
  IMPLEMENT_MOCK2(setApartmentTemperatureStatusEcoPreferred);
  IMPLEMENT_CONST_MOCK0(apartmentWeatherStatus);
  IMPLEMENT_CONST_MOCK0(apartmentEnvironmentStatus);
  IMPLEMENT_CONST_MOCK0(apartmentMeasurementStatus);
  IMPLEMENT_CONST_MOCK1(zoneMeasurementsStatus);
  IMPLEMENT_CONST_MOCK1(temperatureStatus);
  IMPLEMENT_CONST_MOCK1(zoneApplicationsStatus);
  IMPLEMENT_CONST_MOCK1(temperatureApplication);
  IMPLEMENT_MOCK2(setTemperatureSetpoint);
  IMPLEMENT_MOCK2(setTemperatureStatusSetpoint);
  IMPLEMENT_MOCK2(setTemperatureStatusSetbackRequested);
  IMPLEMENT_MOCK2(setTemperatureStatusEcoPreferred);

  IMPLEMENT_CONST_MOCK0(applications);

  IMPLEMENT_CONST_MOCK0(apartment);
  IMPLEMENT_MOCK0(pollApartment);

  IMPLEMENT_CONST_MOCK0(apartmentStatus);
  IMPLEMENT_MOCK0(pollApartmentStatus);

  IMPLEMENT_CONST_MOCK0(userDefinedStates);
  IMPLEMENT_CONST_MOCK0(userDefinedStateStatuses);
  IMPLEMENT_MOCK2(setUserDefinedStateStatus);
  IMPLEMENT_CONST_MOCK0(meterings);
  IMPLEMENT_CONST_MOCK1(metering);
  IMPLEMENT_CONST_MOCK0(meteringValues);
  IMPLEMENT_CONST_MOCK1(meteringValue);

  IMPLEMENT_MOCK1(updateParameterCache);
  IMPLEMENT_CONST_MOCK0(parameterCacheStatus);

  IMPLEMENT_CONST_MOCK1(floor);
  IMPLEMENT_CONST_MOCK0(floors);
  IMPLEMENT_MOCK2(setFloorName);

  IMPLEMENT_CONST_MOCK0(installation);
  IMPLEMENT_CONST_MOCK0(dsServer);
};

} // namespace dsModel
