#pragma once

#include "ds-api/rest-fwd.h"
#include "string"

namespace dsModel {

enum class MeasurementType;
enum class MeasurementUsage;
enum class SensorStatusStatus;
enum class ButtonType;
enum class ButtonMode;
enum class StateType;
enum class StateMode;
enum class StateStatusStatus;
enum class OutputType;
enum class OutputFunction;
enum class OutputMode;
enum class OutputStatusStatus;
enum class ZoneApplicationType;
enum class ClusterApplicationType;
enum class AreaApplicationType;
enum class ShadeDeviceType;
enum class ShadeProtectionClass;
enum class ShadeOrientation;
enum class ApartmentActionId;
enum class ZoneActionId;
enum class LightsActionId;
enum class ShadesActionId;
enum class AudioActionId;
enum class DeviceActionId;
enum class CommonActionId;
enum class LightsStatusStatus;
enum class ShadesStatusStatus;
enum class AwningsStatusStatus;
enum class AudioStatusStatus;
enum class VentilationStatusStatus;
enum class RecirculationStatusStatus;
enum class UserDefinedStateStatusStatus;
enum class ParameterCacheStatus;

struct Origin;
struct SensorAttributes;
struct Sensor;
struct SensorStatus;
struct ButtonAttributes;
struct Button;
struct StateAttributes;
struct State;
struct StateStatus;
struct OutputAttributes;
struct Output;
struct OutputStatus;
struct FunctionBlockAttributes;
struct FunctionBlockId;
using FunctionBlock = dsApi::ResourceData<FunctionBlockId, FunctionBlockAttributes>;
struct FunctionBlockStatus;
struct SubmoduleAttributes;
struct SubmoduleId;
using Submodule = dsApi::ResourceData<SubmoduleId, SubmoduleAttributes>;
struct ShadeAttributes;
struct DSDeviceAttributes;
struct DeviceId;
using DSDevice = dsApi::ResourceData<DeviceId, DSDeviceAttributes>;
struct DSDeviceStatusAttributes;
using DSDeviceStatus = dsApi::ResourceData<DeviceId, DSDeviceStatusAttributes>;

struct ZoneAttributes;
struct ZoneId;
using Zone = dsApi::ResourceData<ZoneId, ZoneAttributes>;

struct ClusterAttributes;
struct ClusterIncluded;
struct ClusterId;
using Cluster = dsApi::ResourceDataWithIncluded<ClusterId, ClusterAttributes, ClusterIncluded>;
struct ClusterWeatherStatus;
struct ClusterStatusAttributes;
using ClusterStatus = dsApi::ResourceData<ClusterId, ClusterStatusAttributes>;

struct VentilationApplicationAttributes;
struct TemperatureSetpoint;
struct TemperatureApplicationAttributes;
struct ApplicationId;
using Application = dsApi::VariantResourceData<dsModel::ApplicationId, dsModel::TemperatureApplicationAttributes,
                                               dsModel::VentilationApplicationAttributes>;

struct ZoneMeasurementsStatus;
struct LightsStatus;
struct ShadesStatus;
struct AwningsStatus;
struct AudioStatus;
struct VentilationStatus;
struct RecirculationStatus;
struct TemperatureStatus;
struct ZoneApplicationsStatus;
struct ZoneStatusAttributes;
using ZoneStatus = dsApi::ResourceData<ZoneId, ZoneStatusAttributes>;

struct ApartmentAttributes;
struct ApartmentIncluded;
using Apartment = dsApi::ResourceDataWithIncluded<std::string, ApartmentAttributes, ApartmentIncluded>;

struct GroupStatus;
struct AppartmentApplicationsStatus;
struct ApartmentAccessStatus;
struct ApartmentUserStatus;
struct ApartmentSecurityStatus;
struct ApartmentWeatherStatus;
struct ApartmentEnvironmentStatus;
struct ApartmentMeasurementStatus;
struct ApartmentStatusAttributes;
struct ApartmentStatusIncluded;
using ApartmentStatus =
    dsApi::ResourceDataWithIncluded<std::string, ApartmentStatusAttributes, ApartmentStatusIncluded>;

struct FunctionBlockParameterCacheAttributes;
using FunctionBlockParameterCache = dsApi::ResourceData<std::string, FunctionBlockParameterCacheAttributes>;

struct ParameterCacheAttributes;
struct ParameterCacheIncluded;
using ParameterCache = dsApi::ResourceDataWithIncluded<std::string, ParameterCacheAttributes, ParameterCacheIncluded>;

struct UserDefinedStateAttributes;
using UserDefinedState = dsApi::ResourceData<std::string, UserDefinedStateAttributes>;
struct UserDefinedStateStatusAttributes;
using UserDefinedStateStatus = dsApi::ResourceData<std::string, UserDefinedStateStatusAttributes>;

struct FloorAttributes;
struct FloorId;
using Floor = dsApi::ResourceData<FloorId, FloorAttributes>;
struct Floors;

struct MeteringAttributes;
struct MeteringId;
using Metering = dsApi::ResourceData<MeteringId, MeteringAttributes>;
struct Meterings;

struct MeteringValueAttributes;
using MeteringValue = dsApi::ResourceData<MeteringId, MeteringValueAttributes>;
struct MeteringValues;

struct InstallationAttributes;
struct InstallationId;
using Installation = dsApi::ResourceData<InstallationId, InstallationAttributes>;

struct DSServerAttributes;
struct ServerId;
using DSServer = dsApi::ResourceData<ServerId, DSServerAttributes>;

struct DeviceState;
struct DeviceStateStatus;
struct DeviceStateOption;

} // namespace dsModel
