#include "model.h"

namespace dsModel {
const dsApi::EventType apartmentStructureChanged{"apartmentStructureChanged"};
const dsApi::EventType apartmentStatusChanged{"apartmentStatusChanged"};
const dsApi::EventType meteringValues{"meteringValues"};
} // namespace dsModel

DS_JSON_DEFINE_STRUCT((dsModel), Origin);
DS_JSON_DEFINE_STRUCT((dsModel), SensorAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Sensor);
DS_JSON_DEFINE_STRUCT((dsModel), SensorStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ButtonAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Button);
DS_JSON_DEFINE_STRUCT((dsModel), StateAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), State);
DS_JSON_DEFINE_STRUCT((dsModel), StateStatus);
DS_JSON_DEFINE_STRUCT((dsModel), OutputAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Output);
DS_JSON_DEFINE_STRUCT((dsModel), OutputStatus);
DS_JSON_DEFINE_STRUCT((dsModel), FunctionBlockAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), FunctionBlock);
DS_JSON_DEFINE_STRUCT((dsModel), FunctionBlockStatus);
DS_JSON_DEFINE_STRUCT((dsModel), SubmoduleAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ShadeAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Submodule);
DS_JSON_DEFINE_STRUCT((dsModel), DSDeviceAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), DSDevice);
DS_JSON_DEFINE_STRUCT((dsModel), DSDeviceStatusAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), DSDeviceStatus);

DS_JSON_DEFINE_STRUCT((dsModel), ZoneAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Zone);

DS_JSON_DEFINE_STRUCT((dsModel), ClusterAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ClusterIncluded);
DS_JSON_DEFINE_STRUCT((dsModel), Cluster);
DS_JSON_DEFINE_STRUCT((dsModel), ClusterWeatherStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ClusterStatusAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ClusterStatus);

DS_JSON_DEFINE_STRUCT((dsModel), VentilationApplicationAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), TemperatureSetpoint);
DS_JSON_DEFINE_STRUCT((dsModel), TemperatureApplicationAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Application);
DS_JSON_DEFINE_STRUCT((dsModel), ScenarioStatus);

DS_JSON_DEFINE_STRUCT((dsModel), Coordinates);
DS_JSON_DEFINE_STRUCT((dsModel), InstallationAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Installation);

DS_JSON_DEFINE_STRUCT((dsModel), DSServerAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), DSServer);

DS_JSON_DEFINE_STRUCT((dsModel), ApartmentAlarm);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentSecurity);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentIncluded);
DS_JSON_DEFINE_STRUCT((dsModel), Apartment);

DS_JSON_DEFINE_STRUCT((dsModel), ZoneMeasurementsStatus);
DS_JSON_DEFINE_STRUCT((dsModel), LightsStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ShadesStatus);
DS_JSON_DEFINE_STRUCT((dsModel), AwningsStatus);
DS_JSON_DEFINE_STRUCT((dsModel), AudioStatus);
DS_JSON_DEFINE_STRUCT((dsModel), VentilationStatus);
DS_JSON_DEFINE_STRUCT((dsModel), RecirculationStatus);
DS_JSON_DEFINE_STRUCT((dsModel), TemperatureStatus)
DS_JSON_DEFINE_STRUCT((dsModel), ZoneApplicationsStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ZoneStatusAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ZoneStatus);
DS_JSON_DEFINE_STRUCT((dsModel), GroupStatus);
DS_JSON_DEFINE_STRUCT((dsModel), AppartmentApplicationsStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentAccessStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentUserStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentSecurityStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentTemperatureStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentWeatherStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentEnvironmentStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentMeasurementStatus);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentStatusAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentStatusIncluded);
DS_JSON_DEFINE_STRUCT((dsModel), ApartmentStatus);
DS_JSON_DEFINE_STRUCT((dsModel), FunctionBlockParameterCacheAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), FunctionBlockParameterCache);
DS_JSON_DEFINE_STRUCT((dsModel), ParameterCacheAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), ParameterCacheIncluded);
DS_JSON_DEFINE_STRUCT((dsModel), ParameterCache);
DS_JSON_DEFINE_STRUCT((dsModel), UserDefinedStateAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), UserDefinedState);
DS_JSON_DEFINE_STRUCT((dsModel), UserDefinedStateStatusAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), UserDefinedStateStatus);

DS_JSON_DEFINE_STRUCT((dsModel), MeteringAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Metering);
DS_JSON_DEFINE_STRUCT((dsModel), Meterings);

DS_JSON_DEFINE_STRUCT((dsModel), MeteringValueAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), MeteringValue);
DS_JSON_DEFINE_STRUCT((dsModel), MeteringValues);

DS_JSON_DEFINE_STRUCT((dsModel), FloorAttributes);
DS_JSON_DEFINE_STRUCT((dsModel), Floor);
DS_JSON_DEFINE_STRUCT((dsModel), Floors);

DS_JSON_DEFINE_STRUCT((dsModel), DeviceState);
DS_JSON_DEFINE_STRUCT((dsModel), DeviceStateStatus);
DS_JSON_DEFINE_STRUCT((dsModel), DeviceStateOption);
