/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>
#include "scenarios.h"

namespace dsModel {

class ScenariosApiMock : public trompeloeil::mock_interface<ScenariosApi> {
public:
  IMPLEMENT_CONST_MOCK0(applicationZoneScenarios);
  IMPLEMENT_CONST_MOCK0(userDefinedActions);
  IMPLEMENT_CONST_MOCK0(deviceScenarios);
  IMPLEMENT_CONST_MOCK0(scenarios);
  IMPLEMENT_MOCK1(invokeStandardScenario);
  IMPLEMENT_MOCK1(createScenario);
  IMPLEMENT_MOCK1(deleteScenario);
  IMPLEMENT_MOCK2(setScenarioName);
  IMPLEMENT_MOCK1(invokeScenario);
  IMPLEMENT_MOCK1(persistScenario);
};

} // namespace dsModel
