#pragma once

#include <ds-model/model-ids.h>
#include <ds-model/scenarios-fwd.h>
#include <ds-model/scenarios-ids.h>
#include <ds/asio/resource-fwd.h>
#include "model/apartment.h"

///
/// Glue between dss model and ds model
///

namespace dss {

struct ApplicationZoneScenarioId {
  int zone;
  int group;
  int scene;
};
BOOST_STRONG_TYPEDEF(std::string, UserDefinedActionId);
struct DeviceScenarioId {
  dsModel::DeviceId device;
  dsModel::DeviceScenarioActionId action;
};
using DecodedScenarioId = std::variant<ApplicationZoneScenarioId, UserDefinedActionId, DeviceScenarioId>;

std::vector<ApplicationZoneScenarioId> zoneApplicationScenarioIds(dss::Zone&);
std::vector<dsModel::ScenarioId> zoneScenarioIds(dss::Zone&);
DecodedScenarioId decodeId(const dsModel::ScenarioId& id);
dsModel::ScenarioId encodeId(const DecodedScenarioId& id);

std::unique_ptr<dsModel::ScenariosApi> makeDsScenarios(ds::asio::ResourceBase& parent, Apartment&);

} // namespace dss

DS_REFLECT_STRUCT((dss), ApplicationZoneScenarioId, (zone)(group)(scene));
DS_REFLECT_STRUCT((dss), DeviceScenarioId, (device)(action));
