/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#include "loop.h"
#include <ds/asio/catch.h>
#include <ds/log.h>
#include <future>
#include "loop-impl.h"

static const char* TAGS = "[dsAsioLoop][dsAsio][ds]";
using namespace std::chrono_literals;

SCENARIO("dsAsioLoopImpl", TAGS) {
  auto loop = ds::asio::LoopImpl{};

  SECTION("executes handlers in another threas") {
    auto task = std::packaged_task<void(void)>([] {});
    loop.io.post([&] { task(); });
    task.get_future().get();
  }

  SECTION("exceptions are swallowed") {
    loop.io.post([&] { DS_FAIL_REQUIRE("test"); });

    auto task = std::packaged_task<void(void)>([] {});
    loop.io.post([&] { task(); });
    task.get_future().get();
  }
}
