/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#include "resource.h"

namespace ds::asio {

ResourceBase::ResourceBase(ResourceContext& context, std::string&& id) : m_context{context}, m_id{std::move(id)} {}

ResourceBase::ResourceBase(ResourceBase& parent, std::string_view localId)
    : m_context{parent.context()}, m_id{ds::str(parent.id(), "-", localId)} {}

std::ostream& operator<<(std::ostream& ostream, const ResourceBase& x) {
  return ostream << x.id();
}

} // namespace ds::asio
