/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>
#include "ds-signal.h"

namespace ds {

class VoidSlotMock : public ds::Slot<> {
public:
  VoidSlotMock(boost::asio::io_service &io, ds::Slots<> &slots)
      : ds::Slot<>(io, slots, [this](const auto &... args) { called(args...); }) {}
  MAKE_MOCK0(called, void());
};

#define DS_SLOT_MOCK1(name, _1)                                                         \
  class name : public ds::Slot<_1> {                                                    \
  public:                                                                               \
    name(boost::asio::io_service &io, ds::Slots<_1> &slots)                             \
        : ds::Slot<_1>(io, slots, [this](const auto &... args) { called(args...); }) {} \
    MAKE_MOCK1(called, void(const _1 &));                                               \
  };

} // namespace ds
