/*
    Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#include "elapsed.h"

namespace ds {

std::ostream& operator<<(std::ostream& ostream, const Elapsed& x) {
  auto duration = x.elapsed();

  if (duration > std::chrono::hours(24) * 9) {
    return ostream << (std::chrono::duration_cast<std::chrono::hours>(duration).count() / 24) << "d";
  } else if (duration > std::chrono::hours(9)) {
    return ostream << std::chrono::duration_cast<std::chrono::hours>(duration).count() << "h";
  } else if (duration > std::chrono::minutes(9)) {
    return ostream << std::chrono::duration_cast<std::chrono::minutes>(duration).count() << "m";
  } else if (duration > std::chrono::seconds(9)) {
    return ostream << std::chrono::duration_cast<std::chrono::seconds>(duration).count() << "s";
  } else if (duration > std::chrono::milliseconds(9)) {
    return ostream << std::chrono::duration_cast<std::chrono::milliseconds>(duration).count() << "ms";
  } else {
    return ostream << std::chrono::duration_cast<std::chrono::microseconds>(duration).count() << "us";
  }
}

} // namespace ds
