#include "promise.h"
#include <ds/catch/catch.h>
#include <trompeloeil.hpp>

static const char *TAGS = "[dsPromise][ds]";

using namespace trompeloeil;

namespace {

struct BoolFulfilled {
public:
  MAKE_MOCK1(call, void(std::optional<bool>));
};

TEST_CASE("dsPromise", TAGS) {
  GIVEN("bool promise") {
    auto boolFulfilled = BoolFulfilled{};
    auto promise = ds::makePromise<bool>([&](std::optional<bool> &&x) { boolFulfilled.call(std::move(x)); });

    THEN("fulfilled with nulopt on promise reset") {
      REQUIRE_CALL(boolFulfilled, call(std::nullopt));
      promise.reset();
      SUCCEED();
    }

    THEN("fulfilled with value on promise reset") {
      promise->value = true;
      REQUIRE_CALL(boolFulfilled, call(true));
      promise.reset();
      SUCCEED();
    }
  }
}

} // namespace
