/*
    Copyright (c) 2016 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#include "random.h"
#include <random>
#include <string_view>
#include "common.h"
using namespace std::literals;

namespace ds {

std::default_random_engine& threadLocalRandomEngine() {
  thread_local std::default_random_engine engine = [] {
    std::random_device device;
    return std::default_random_engine(device());
  }();
  return engine;
}

std::string randomId() {
  constexpr auto chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"sv;
  auto& randomEngine = threadLocalRandomEngine();
  auto charIndexRandomDistribution = std::uniform_int_distribution<int>(0, chars.size() - 1);
  std::string result;
  const int size = 16;
  result.reserve(size);
  for (int i = 0; i < size; i++) {
    result.push_back(chars[charIndexRandomDistribution(randomEngine)]);
  }
  return result;
}

} // namespace ds
