/*
    Copyright (c) 2009,2010 digitalSTROM.org, Zurich, Switzerland

    Author: Patrick Staehlin, futureLAB AG <pstaehlin@futurelab.ch>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_BUILD_INFO_H
#include "build_info.h"
#endif

#include "dss.h"

#include <algorithm>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#ifndef WIN32
#include <csignal>
#endif

#include <sys/resource.h>
#include <condition_variable>
#include <thread>

#include <boost/algorithm/string/finder.hpp>
#include <boost/algorithm/string/predicate.hpp>
#include <boost/asio/io_service.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/path.hpp>
#include <boost/make_shared.hpp>

#include <ds/log.h>
#include <ds/tracing.h>
#include "backend-vdcs.h"
#include "bus.h"
#include "defaultbuseventsink.h"
#include "ds485/dsbusinterface.h"
#include "event.h"
#include "eventinterpreterplugins.h"
#include "eventinterpretersystemplugins.h"
#include "handler/system_states.h"
#include "heatingregistering.h"
#include "logger.h"
#include "model/apartment.h"
#include "model/dsmeter.h"
#include "model/modelmaintenance.h"
#include "propertysystem.h"
#include "sensor_data_uploader.h"
#include "subscription_profiler.h"
#include "web/webserver.h"
#ifdef WITH_BONJOUR
#include "bonjour.h"
#endif

#include "metering/metering.h"
#include "sessionmanager.h"
#include "watchdog.h"

#include "security/privilege.h"
#include "security/security.h"
#include "security/user.h"

#include "unix/systeminfo.h"

#include "scripting/jsevent.h"
#include "scripting/jsmetering.h"
#include "scripting/jsmodel.h"

#include "model-features.h"
#include "propertysystem_common_paths.h"
#include "vdc-db.h"
#include "vdc-token.h"
#include "webservice_connection.h"

#include "cache/apartment-proxy.h"
#include "cache/cache-updater.h"
#include "hal/hardware-abstraction.h"
