/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>
#include "vdc-db.h"

namespace dss {

class VdcDbMock : public trompeloeil::mock_interface<VdcDb> {
public:
  IMPLEMENT_MOCK1(getSpec);
  IMPLEMENT_MOCK1(getStatesLegacy);
  IMPLEMENT_MOCK1(getStates);
  IMPLEMENT_MOCK1(getEvents);
  IMPLEMENT_MOCK1(getProperties);
  IMPLEMENT_MOCK1(getSensors);
  IMPLEMENT_MOCK1(getActions);
  IMPLEMENT_MOCK1(getStandardActions);
  IMPLEMENT_MOCK1(getCategories);
  IMPLEMENT_MOCK1(getOutputs);
  IMPLEMENT_MOCK1(hasActionInterface);
};

} // namespace dss
