/*
    Copyright (c) 2017 digitalSTROM AG, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __INTERNAL_REQUEST_HANDLER_H__
#define __INTERNAL_REQUEST_HANDLER_H__

#include "structuremanipulator.h"

#include "web/webrequests.h"
#include <boost/shared_ptr.hpp>

class Device;
class EventInterpreter;

namespace dss {
  class InternalRequestHandler : public WebServerRequestHandlerJSON {
  public:
    InternalRequestHandler(Apartment& _apartment,
                           StructureModifyingBusInterface &,
                           StructureQueryBusInterface &,
                           EventInterpreter &);
    virtual WebServerResponse jsonHandleRequest(const RestfulRequest& _request, boost::shared_ptr<Session> _session, const struct mg_connection* _connection);

  private:
    Apartment& m_Apartment;
    StructureManipulator m_manipulator;

    // rental reset helper functions
    bool needToClearName(boost::shared_ptr<const Device> device);
    void removeCustomActions(boost::shared_ptr<Device> device);
    std::string resetSceneConfiguration();
    std::string getRentalResetJSON();
  }; // InternalRequestHandler
}

#endif /* __INTERNAL_REQUEST_HANDLER_H__ */
