/*
    Copyright (c) 2017 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <string>

#include "ds/json.h"
#include "ds/reflect.h"

#include "dssfwd.h"
#include "eventobserver.h"
#include "model/modelconst.h"

namespace dss {

namespace websocket {

struct IdentifyDeviceParams {
  std::string dsmID;
};

struct IdentifyDeviceEvent {
  std::string dsuid;
  std::string description;
};

class IdentifyDevice : public EventObserver {
public:
  IdentifyDevice();
  bool checkIfForMe(const Event& e) const override;
  ds::JsonFragment toJson(const Event& e) const override;

  std::string buildDescription(boost::shared_ptr<const DeviceReference> device, const Event& e) const;
  std::string displayButton(int id, int index, int count) const;

  std::string m_dsmID;
};

} // namespace websocket

} // namespace dss

DS_REFLECT_STRUCT((dss)(websocket), IdentifyDeviceParams, (dsmID));
DS_REFLECT_STRUCT((dss)(websocket), IdentifyDeviceEvent, (dsuid)(description));
