/*
    Copyright (c) 2017 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "simpleserver.h"

#include <string>
#include <vector>

#include "dssfwd.h"

namespace dss {

namespace websocket {

///
/// \brief The JsonApiServer class should allow connect user by standard WebSocket.
/// It works in request-response model and event registration.
///
class JsonApiServer : public SimpleServer {
public:
  JsonApiServer(const std::string &url, size_t maxClientCount) : SimpleServer(url, maxClientCount) {}

  boost::shared_ptr<Connection> createConnectionData(mg_connection *con) const override;

protected:
  bool shouldSend(const Event &e, const Connection &c) const override;

  void prepareAndSendMsgs(const Event &e, Connection &c) const override;

  int dataHandler(mg_connection *connection, int number, char *msg, size_t msgSize, void *cbdata) override;

  void handleRequest(const std::string &msg, mg_connection *connection);
};

} // namespace websocket

} // namespace dss
