/*
    Copyright (c) 2017 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#include "message.h"

#include <iostream>

namespace dss {

namespace websocket {

ds::Enum<MessageType> dsEnum(MessageType) {
  static constexpr std::pair<MessageType, const char*> x[] = {{MessageType::REQUEST, "request"},
      {MessageType::EVENT, "event"}, {MessageType::REPLY, "reply"}, {MessageType::CANCEL, "cancel"}};
  return {gsl::make_span(x), "dss::websocket::MessageType"};
}

std::ostream& operator<<(std::ostream& stream, MessageType x) { return ds::ostream(stream, x); }

} // namespace websocket

} // namespace dss
