#/bin/bash

# Extracts translated strings from sources passed as arguments.
# Helper script invoked from Makefile

set -e

POT_FILE="../po/dss-mainline.pot"

cd ${TOP_SRCDIR:-..}/build

xgettext --c++ --force-po --from-code=UTF-8 \
  --package-name=dss-mainline \
  --keyword=dsMessage:1,1t --keyword=dsMessage:1c,2,2t --keyword=dsMessage:1,2,3t --keyword=dsMessage:1c,2,3,4t \
  --keyword=dsTr:2,2t --keyword=dsTr:2c,3,3t \
  --keyword=dsApiTranslation:2c,3,3t \
  --keyword=dsTr:2,3,4t --keyword=dsTr:2c,3,4,5t \
  -o ${POT_FILE} "$@"

# Fix content type after xgettext.
# Is there a way to persuade xgettext to set UTF-8 content type?
sed -i 's%^"Content-Type: text/plain; charset=CHARSET\\n"%"Content-Type: text/plain; charset=UTF-8\\n"%' ${POT_FILE}
