#/bin/bash

# Compiles and installs all .po files as .mo files

set -e

cd ${TOP_SRCDIR:-.}
. ./tx-env.sh

destlocaledir="$1"
if [ -z "${destlocaledir}" ]; then
    echo "Usage: tx-install.sh destlocaledir"
    exit 1
fi

for language in ${languages}; do
    if [ "${language}" == "en_pseudo" ]; then
      continue
    fi
    dir=po/${language}
    modir=${destlocaledir}/${language}/LC_MESSAGES
    mkdir -p ${modir}
    for resource in ${resources}; do
        mo=${modir}/${resource}.mo
        echo ${mo}
        if [ -f ${dir}/${resource}.po ]; then
            msgfmt -o ${mo} ${dir}/${resource}.po
        fi
    done
done
